diff -pruN 3.5.4-1/Changelog 3.6.0-1/Changelog
--- 3.5.4-1/Changelog	2021-01-17 21:04:43.000000000 +0000
+++ 3.6.0-1/Changelog	2021-02-03 20:03:27.000000000 +0000
@@ -1,3 +1,10 @@
+Version 3.6.0     03 Feb 2021
+
+	* Always use '/' internally for paths, even on the Windows platform.
+	* Change the way archive filenames are generated to eliminate leading '-' characters.
+	* Use UTF-8 encoding for log files on disk to avoid problems with unusual filenames.
+	* Update build process to include security scans using Safety.
+
 Version 3.5.4     17 Jan 2021
 
 	* Fix a couple of links in docs/index.rst (cut-and-paste error).
diff -pruN 3.5.4-1/debian/changelog 3.6.0-1/debian/changelog
--- 3.5.4-1/debian/changelog	2021-01-17 21:04:48.000000000 +0000
+++ 3.6.0-1/debian/changelog	2021-02-03 20:03:29.000000000 +0000
@@ -1,3 +1,9 @@
+cedar-backup3 (3.6.0-1) unstable; urgency=medium
+
+  * New upstream release.
+
+ -- Kenneth J. Pronovici <pronovic@debian.org>  Wed, 03 Feb 2021 20:03:29 +0000
+
 cedar-backup3 (3.5.4-1) unstable; urgency=medium
 
   * New upstream release.
diff -pruN 3.5.4-1/docs/requirements.txt 3.6.0-1/docs/requirements.txt
--- 3.5.4-1/docs/requirements.txt	2021-01-17 21:04:43.000000000 +0000
+++ 3.6.0-1/docs/requirements.txt	2021-02-03 20:03:27.000000000 +0000
@@ -1,56 +1,58 @@
-alabaster==0.7.12; python_version >= "3.5" and python_full_version < "3.0.0" or python_full_version >= "3.6.0" and python_version >= "3.5"
+alabaster==0.7.12; python_version >= "3.6"
 appdirs==1.4.4; python_version >= "3.6" and python_full_version < "3.0.0" or python_full_version >= "3.5.0" and python_version >= "3.6"
-astroid==2.4.2; python_version >= "3.5" and python_full_version < "3.0.0" or python_full_version >= "3.6.0" and python_version >= "3.5"
-babel==2.9.0; python_version >= "3.5" and python_full_version < "3.0.0" or python_full_version >= "3.6.0" and python_version >= "3.5"
+astroid==2.4.2; python_version >= "3.6"
+babel==2.9.0; python_version >= "3.6" and python_full_version < "3.0.0" or python_full_version >= "3.4.0" and python_version >= "3.6"
 black==20.8b1; python_version >= "3.6"
 certifi==2020.12.5; python_version >= "3.5" and python_full_version < "3.0.0" or python_full_version >= "3.5.0" and python_version >= "3.5"
 cfgv==3.2.0; python_full_version >= "3.6.1"
 chardet==3.0.4
 click==7.1.2; python_version >= "3.6" and python_full_version < "3.0.0" or python_full_version >= "3.5.0" and python_version >= "3.6"
-colorama==0.4.4; python_version >= "3.5" and python_full_version < "3.0.0" and platform_system == "Windows" and sys_platform == "win32" and (python_version >= "3.5" and python_full_version < "3.0.0" or python_full_version >= "3.6.0" and python_version >= "3.5") or python_full_version >= "3.5.0" and platform_system == "Windows" and sys_platform == "win32" and python_version >= "3.5" and (python_version >= "3.5" and python_full_version < "3.0.0" or python_full_version >= "3.6.0" and python_version >= "3.5")
-coverage==5.3.1; (python_version >= "2.7" and python_full_version < "3.0.0") or (python_full_version >= "3.5.0" and python_version < "4")
+colorama==0.4.4; python_version >= "3.6" and python_full_version < "3.0.0" and platform_system == "Windows" and sys_platform == "win32" or python_full_version >= "3.5.0" and platform_system == "Windows" and sys_platform == "win32" and python_version >= "3.6"
+coverage==5.4; (python_version >= "2.7" and python_full_version < "3.0.0") or (python_full_version >= "3.5.0" and python_version < "4")
 distlib==0.3.1; python_version >= "2.7" and python_full_version < "3.0.0" or python_full_version >= "3.5.0"
-docutils==0.16; python_version >= "3.5" and python_full_version < "3.0.0" or python_full_version >= "3.6.0" and python_version >= "3.5"
+docutils==0.16; python_version >= "3.6" and python_full_version < "3.0.0" or python_full_version >= "3.5.0" and python_version >= "3.6"
+dparse==0.5.1; python_version >= "3.5"
 filelock==3.0.12; python_version >= "2.7" and python_full_version < "3.0.0" or python_full_version >= "3.5.0"
-identify==1.5.12; python_full_version >= "3.6.1"
+identify==1.5.13; python_full_version >= "3.6.1"
 idna==2.10; python_version >= "3.5" and python_full_version < "3.0.0" or python_full_version >= "3.5.0" and python_version >= "3.5"
-imagesize==1.2.0; python_version >= "3.5" and python_full_version < "3.0.0" or python_full_version >= "3.6.0" and python_version >= "3.5"
+imagesize==1.2.0; python_version >= "3.6" and python_full_version < "3.0.0" or python_full_version >= "3.4.0" and python_version >= "3.6"
 importlib-metadata==3.4.0; python_full_version >= "3.6.1" and python_version < "3.8" and python_version >= "3.6" and (python_version >= "3.6" and python_full_version < "3.0.0" and python_version < "3.8" or python_full_version >= "3.5.0" and python_version < "3.8" and python_version >= "3.6")
 isort==5.7.0; python_version >= "3.6" and python_version < "4.0"
-jinja2==2.11.2; python_version >= "3.5" and python_full_version < "3.0.0" or python_full_version >= "3.6.0" and python_version >= "3.5"
+jinja2==2.11.3; python_version >= "3.6" and python_full_version < "3.0.0" or python_full_version >= "3.5.0" and python_version >= "3.6"
 lazy-object-proxy==1.4.3; python_version >= "3.5" and python_full_version < "3.0.0" or python_full_version >= "3.4.0" and python_version >= "3.5"
 markupsafe==1.1.1; python_version >= "3.5" and python_full_version < "3.0.0" or python_full_version >= "3.5.0" and python_version >= "3.5"
 mccabe==0.6.1; python_version >= "3.5"
 mypy-extensions==0.4.3; python_version >= "3.6"
 nodeenv==1.5.0; python_full_version >= "3.6.1"
-packaging==20.8; python_version >= "3.5" and python_full_version < "3.0.0" or python_full_version >= "3.6.0" and python_version >= "3.5"
+packaging==20.9; python_version >= "3.6" and python_full_version < "3.0.0" or python_full_version >= "3.5.0" and python_version >= "3.6"
 pathspec==0.8.1; python_version >= "3.6" and python_full_version < "3.0.0" or python_full_version >= "3.5.0" and python_version >= "3.6"
 pluggy==0.13.1; python_version >= "2.7" and python_full_version < "3.0.0" or python_full_version >= "3.5.0"
-pre-commit==2.9.3; python_full_version >= "3.6.1"
+pre-commit==2.10.0; python_full_version >= "3.6.1"
 py==1.10.0; python_version >= "2.7" and python_full_version < "3.0.0" or python_full_version >= "3.5.0"
-pygments==2.7.4; python_version >= "3.5" and python_full_version < "3.0.0" or python_full_version >= "3.6.0" and python_version >= "3.5"
+pygments==2.7.4; python_version >= "3.6"
 pylint==2.6.0; python_version >= "3.5"
 pyparsing==2.4.7; python_version >= "2.7" and python_full_version < "3.0.0" or python_full_version >= "3.5.0"
-pytz==2020.5; python_version >= "3.5" and python_full_version < "3.0.0" or python_full_version >= "3.4.0" and python_version >= "3.5"
-pyyaml==5.3.1; python_full_version >= "3.6.1"
+pytz==2021.1; python_version >= "3.5" and python_full_version < "3.0.0" or python_full_version >= "3.4.0" and python_version >= "3.5"
+pyyaml==5.4.1; python_full_version >= "3.6.1" and python_version >= "3.6" and (python_version >= "3.5" and python_full_version < "3.0.0" or python_full_version >= "3.6.0" and python_version >= "3.5")
 regex==2020.11.13; python_version >= "3.6"
-requests==2.25.1; python_version >= "3.5" and python_full_version < "3.0.0" or python_full_version >= "3.6.0" and python_version >= "3.5"
+requests==2.25.1; python_version >= "3.6" and python_full_version < "3.0.0" or python_full_version >= "3.5.0" and python_version >= "3.6"
+safety==1.10.3; python_version >= "3.5"
 six==1.15.0; python_version >= "3.5" and python_full_version < "3.0.0" or python_full_version >= "3.5.0" and python_version >= "3.5"
-snowballstemmer==2.0.0; python_version >= "3.5" and python_full_version < "3.0.0" or python_full_version >= "3.6.0" and python_version >= "3.5"
-sphinx-autoapi==1.5.1; (python_version >= "2.7" and python_full_version < "3.0.0") or (python_full_version >= "3.6.0")
+snowballstemmer==2.1.0; python_version >= "3.6"
+sphinx-autoapi==1.7.0; python_version >= "3.6"
 sphinx==3.4.3; python_version >= "3.5"
-sphinxcontrib-applehelp==1.0.2; python_version >= "3.5" and python_full_version < "3.0.0" or python_full_version >= "3.6.0" and python_version >= "3.5"
-sphinxcontrib-devhelp==1.0.2; python_version >= "3.5" and python_full_version < "3.0.0" or python_full_version >= "3.6.0" and python_version >= "3.5"
-sphinxcontrib-htmlhelp==1.0.3; python_version >= "3.5" and python_full_version < "3.0.0" or python_full_version >= "3.6.0" and python_version >= "3.5"
-sphinxcontrib-jsmath==1.0.1; python_version >= "3.5" and python_full_version < "3.0.0" or python_full_version >= "3.6.0" and python_version >= "3.5"
-sphinxcontrib-qthelp==1.0.3; python_version >= "3.5" and python_full_version < "3.0.0" or python_full_version >= "3.6.0" and python_version >= "3.5"
-sphinxcontrib-serializinghtml==1.1.4; python_version >= "3.5" and python_full_version < "3.0.0" or python_full_version >= "3.6.0" and python_version >= "3.5"
+sphinxcontrib-applehelp==1.0.2; python_version >= "3.6"
+sphinxcontrib-devhelp==1.0.2; python_version >= "3.6"
+sphinxcontrib-htmlhelp==1.0.3; python_version >= "3.6"
+sphinxcontrib-jsmath==1.0.1; python_version >= "3.6"
+sphinxcontrib-qthelp==1.0.3; python_version >= "3.6"
+sphinxcontrib-serializinghtml==1.1.4; python_version >= "3.6"
 toml==0.10.2; (python_version >= "2.6" and python_full_version < "3.0.0") or (python_full_version >= "3.3.0")
-tox==3.21.1; (python_version >= "2.7" and python_full_version < "3.0.0") or (python_full_version >= "3.5.0")
+tox==3.21.4; (python_version >= "2.7" and python_full_version < "3.0.0") or (python_full_version >= "3.5.0")
 typed-ast==1.4.2; implementation_name == "cpython" and python_version < "3.8" and python_version >= "3.6"
 typing-extensions==3.7.4.3; python_version >= "3.6" and python_full_version < "3.0.0" and python_version < "3.8" or python_full_version >= "3.5.0" and python_version < "3.8" and python_version >= "3.6"
-unidecode==1.1.2; python_version >= "2.7" and python_full_version < "3.0.0" or python_full_version >= "3.6.0"
-urllib3==1.26.2; python_version >= "3.5" and python_full_version < "3.0.0" or python_full_version >= "3.5.0" and python_version < "4" and python_version >= "3.5"
-virtualenv==20.3.1; python_full_version >= "3.6.1"
+unidecode==1.1.2; python_version >= "3.6" and python_full_version < "3.0.0" or python_full_version >= "3.4.0" and python_version >= "3.6"
+urllib3==1.26.3; python_version >= "3.5" and python_full_version < "3.0.0" or python_full_version >= "3.5.0" and python_version < "4" and python_version >= "3.5"
+virtualenv==20.4.2; python_full_version >= "3.6.1"
 wrapt==1.12.1; python_version >= "3.5"
 zipp==3.4.0; python_version >= "3.6" and python_full_version < "3.0.0" and python_version < "3.8" or python_full_version >= "3.5.0" and python_version < "3.8" and python_version >= "3.6"
diff -pruN 3.5.4-1/PKG-INFO 3.6.0-1/PKG-INFO
--- 3.5.4-1/PKG-INFO	2021-01-17 21:04:43.000000000 +0000
+++ 3.6.0-1/PKG-INFO	2021-02-03 20:03:27.000000000 +0000
@@ -1,6 +1,6 @@
 Metadata-Version: 2.1
 Name: cedar-backup3
-Version: 3.5.4
+Version: 3.6.0
 Summary: Implements local and remote backups to CD/DVD and Amazon S3
 Home-page: https://pypi.org/project/cedar-backup3/
 License: GPL-2.0-only
diff -pruN 3.5.4-1/pyproject.toml 3.6.0-1/pyproject.toml
--- 3.5.4-1/pyproject.toml	2021-01-17 21:04:43.000000000 +0000
+++ 3.6.0-1/pyproject.toml	2021-02-03 20:03:27.000000000 +0000
@@ -1,6 +1,6 @@
 [tool.poetry]
 name = "cedar-backup3"
-version = "3.5.4"
+version = "3.6.0"
 description = "Implements local and remote backups to CD/DVD and Amazon S3"
 keywords = [ 'local', 'remote', 'backup', 'scp' ]
 authors = ["Kenneth J. Pronovici <pronovic@ieee.org>"]
@@ -42,6 +42,7 @@ pre-commit = "^2.2.0"
 black = "^20.8b1"
 isort = "^5.0.0"
 sphinx-autoapi = "^1.2.1"
+safety = "^1.10.3"
 
 [tool.black]
 line-length = 132
diff -pruN 3.5.4-1/setup.py 3.6.0-1/setup.py
--- 3.5.4-1/setup.py	2021-01-17 21:04:43.000000000 +0000
+++ 3.6.0-1/setup.py	2021-02-03 20:03:27.000000000 +0000
@@ -24,7 +24,7 @@ entry_points = \
 
 setup_kwargs = {
     'name': 'cedar-backup3',
-    'version': '3.5.4',
+    'version': '3.6.0',
     'description': 'Implements local and remote backups to CD/DVD and Amazon S3',
     'long_description': '[![pypi](https://img.shields.io/pypi/v/cedar-backup3.svg)](https://pypi.org/project/cedar-backup3/)\n[![license](https://img.shields.io/pypi/l/cedar-backup3.svg)](https://github.com/pronovic/cedar-backup3/blob/master/LICENSE)\n[![wheel](https://img.shields.io/pypi/wheel/cedar-backup3.svg)](https://pypi.org/project/cedar-backup3/)\n[![python](https://img.shields.io/pypi/pyversions/cedar-backup3.svg)](https://pypi.org/project/cedar-backup3/)\n[![Test Suite](https://github.com/pronovic/cedar-backup3/workflows/Test%20Suite/badge.svg)](https://github.com/pronovic/cedar-backup3/actions?query=workflow%3A%22Test+Suite%22)\n[![docs](https://readthedocs.org/projects/cedar-backup3/badge/?version=stable&style=flat)](https://cedar-backup3.readthedocs.io/en/stable/)\n\n[Cedar Backup](https://github.com/pronovic/cedar-backup3) is a software package\ndesigned to manage system backups for a pool of local and remote machines.\nCedar Backup understands how to back up filesystem data as well as MySQL and\nPostgreSQL databases and Subversion repositories.  It can also be easily\nextended to support other kinds of data sources.\n\nCedar Backup is focused around weekly backups to a single CD or DVD disc,\nwith the expectation that the disc will be changed or overwritten at the\nbeginning of each week.  If your hardware is new enough, Cedar Backup can\nwrite multisession discs, allowing you to add incremental data to a disc on\na daily basis.  Alternately, Cedar Backup can write your backups to the Amazon\nS3 cloud rather than relying on physical media.  See \nthe [Cedar Backup v3 Software Manual](https://cedar-backup3.readthedocs.io/en/stable/manual/index.html) for details.\n\nBesides offering command-line utilities to manage the backup process, Cedar\nBackup provides a well-organized library of backup-related functionality.\nFor more information, see \nthe [API Reference](https://cedar-backup3.readthedocs.io/en/stable/autoapi/index.html).\n\nThere are many different backup software systems in the open source world.\nCedar Backup aims to fill a niche: it aims to be a good fit for people who need\nto back up a limited amount of important data on a regular basis. Cedar Backup\nisn’t for you if you want to back up your huge MP3 collection every night, or\nif you want to back up a few hundred machines.  However, if you administer a\nsmall set of machines and you want to run daily incremental backups for things\nlike system configuration, current email, small web sites, source code\nrepositories, or small databases, then Cedar Backup is probably worth your\ntime.\n',
     'author': 'Kenneth J. Pronovici',
diff -pruN 3.5.4-1/src/CedarBackup3/actions/collect.py 3.6.0-1/src/CedarBackup3/actions/collect.py
--- 3.5.4-1/src/CedarBackup3/actions/collect.py	2021-01-17 21:04:43.000000000 +0000
+++ 3.6.0-1/src/CedarBackup3/actions/collect.py	2021-02-03 20:03:27.000000000 +0000
@@ -52,7 +52,7 @@ import pickle
 from CedarBackup3.actions.constants import COLLECT_INDICATOR, DIGEST_EXTENSION
 from CedarBackup3.actions.util import writeIndicatorFile
 from CedarBackup3.filesystem import BackupFileList, FilesystemList
-from CedarBackup3.util import buildNormalizedPath, changeOwnership, displayBytes, isStartOfWeek
+from CedarBackup3.util import buildNormalizedPath, changeOwnership, displayBytes, isStartOfWeek, pathJoin
 
 ########################################################################
 # Module-wide constants and variables
@@ -549,7 +549,7 @@ def _getDigestPath(config, absolutePath)
     """
     normalized = buildNormalizedPath(absolutePath)
     filename = "%s.%s" % (normalized, DIGEST_EXTENSION)
-    digestPath = os.path.join(config.options.workingDir, filename)
+    digestPath = pathJoin(config.options.workingDir, filename)
     logger.debug("Digest path is [%s]", digestPath)
     return digestPath
 
@@ -577,7 +577,7 @@ def _getTarfilePath(config, absolutePath
         extension = "tar.bz2"
     normalized = buildNormalizedPath(absolutePath)
     filename = "%s.%s" % (normalized, extension)
-    tarfilePath = os.path.join(config.collect.targetDir, filename)
+    tarfilePath = pathJoin(config.collect.targetDir, filename)
     logger.debug("Tarfile path is [%s]", tarfilePath)
     return tarfilePath
 
@@ -614,7 +614,7 @@ def _getExclusions(config, collectDir):
         paths.extend(collectDir.absoluteExcludePaths)
     if collectDir.relativeExcludePaths is not None:
         for relativePath in collectDir.relativeExcludePaths:
-            paths.append(os.path.join(collectDir.absolutePath, relativePath))
+            paths.append(pathJoin(collectDir.absolutePath, relativePath))
     patterns = []
     if config.collect.excludePatterns is not None:
         patterns.extend(config.collect.excludePatterns)
diff -pruN 3.5.4-1/src/CedarBackup3/actions/rebuild.py 3.6.0-1/src/CedarBackup3/actions/rebuild.py
--- 3.5.4-1/src/CedarBackup3/actions/rebuild.py	2021-01-17 21:04:43.000000000 +0000
+++ 3.6.0-1/src/CedarBackup3/actions/rebuild.py	2021-02-03 20:03:27.000000000 +0000
@@ -53,7 +53,7 @@ import sys
 from CedarBackup3.actions.constants import DIR_TIME_FORMAT, STAGE_INDICATOR
 from CedarBackup3.actions.store import consistencyCheck, writeImage, writeStoreIndicator
 from CedarBackup3.actions.util import checkMediaState
-from CedarBackup3.util import deriveDayOfWeek
+from CedarBackup3.util import deriveDayOfWeek, pathJoin
 
 ########################################################################
 # Module-wide constants and variables
@@ -150,8 +150,8 @@ def _findRebuildDirs(config):
     for i in range(0, days):
         currentDay = today - datetime.timedelta(days=i)
         dateSuffix = currentDay.strftime(DIR_TIME_FORMAT)
-        stageDir = os.path.join(config.store.sourceDir, dateSuffix)
-        indicator = os.path.join(stageDir, STAGE_INDICATOR)
+        stageDir = pathJoin(config.store.sourceDir, dateSuffix)
+        indicator = pathJoin(stageDir, STAGE_INDICATOR)
         if os.path.isdir(stageDir) and os.path.exists(indicator):
             logger.info("Rebuild process will include stage directory [%s]", stageDir)
             stagingDirs[stageDir] = dateSuffix
diff -pruN 3.5.4-1/src/CedarBackup3/actions/stage.py 3.6.0-1/src/CedarBackup3/actions/stage.py
--- 3.5.4-1/src/CedarBackup3/actions/stage.py	2021-01-17 21:04:43.000000000 +0000
+++ 3.6.0-1/src/CedarBackup3/actions/stage.py	2021-02-03 20:03:27.000000000 +0000
@@ -52,7 +52,7 @@ import time
 from CedarBackup3.actions.constants import DIR_TIME_FORMAT, STAGE_INDICATOR
 from CedarBackup3.actions.util import writeIndicatorFile
 from CedarBackup3.peer import LocalPeer, RemotePeer
-from CedarBackup3.util import changeOwnership, getUidGid, isRunningAsRoot, isStartOfWeek
+from CedarBackup3.util import changeOwnership, getUidGid, isRunningAsRoot, isStartOfWeek, pathJoin
 
 ########################################################################
 # Module-wide constants and variables
@@ -163,12 +163,12 @@ def _createStagingDirs(config, dailyDir,
         try:
             logger.debug("Creating staging directory [%s].", dailyDir)
             os.makedirs(dailyDir)
-            for path in [dailyDir, os.path.join(dailyDir, ".."), os.path.join(dailyDir, "..", "..")]:
+            for path in [dailyDir, pathJoin(dailyDir, ".."), pathJoin(dailyDir, "..", "..")]:
                 changeOwnership(path, config.options.backupUser, config.options.backupGroup)
         except Exception as e:
             raise Exception("Unable to create staging directory: %s" % e)
     for peer in peers:
-        peerDir = os.path.join(dailyDir, peer.name)
+        peerDir = pathJoin(dailyDir, peer.name)
         mapping[peer.name] = peerDir
         if os.path.isdir(peerDir):
             logger.warning("Peer staging directory [%s] already existed.", peerDir)
@@ -232,7 +232,7 @@ def _getDailyDir(config):
     Returns:
         Path of daily staging directory
     """
-    dailyDir = os.path.join(config.stage.targetDir, time.strftime(DIR_TIME_FORMAT))
+    dailyDir = pathJoin(config.stage.targetDir, time.strftime(DIR_TIME_FORMAT))
     logger.debug("Daily staging directory is [%s].", dailyDir)
     return dailyDir
 
diff -pruN 3.5.4-1/src/CedarBackup3/actions/store.py 3.6.0-1/src/CedarBackup3/actions/store.py
--- 3.5.4-1/src/CedarBackup3/actions/store.py	2021-01-17 21:04:43.000000000 +0000
+++ 3.6.0-1/src/CedarBackup3/actions/store.py	2021-02-03 20:03:27.000000000 +0000
@@ -55,7 +55,7 @@ import tempfile
 from CedarBackup3.actions.constants import DIR_TIME_FORMAT, STAGE_INDICATOR, STORE_INDICATOR
 from CedarBackup3.actions.util import buildMediaLabel, checkMediaState, createWriter, writeIndicatorFile
 from CedarBackup3.filesystem import compareContents
-from CedarBackup3.util import displayBytes, isStartOfWeek, mount, unmount
+from CedarBackup3.util import displayBytes, isStartOfWeek, mount, pathJoin, unmount
 
 ########################################################################
 # Module-wide constants and variables
@@ -313,7 +313,7 @@ def consistencyCheck(config, stagingDirs
     try:
         mount(config.store.devicePath, mountPoint, "iso9660")
         for stagingDir in list(stagingDirs.keys()):
-            discDir = os.path.join(mountPoint, stagingDirs[stagingDir])
+            discDir = pathJoin(mountPoint, stagingDirs[stagingDir])
             logger.debug("Checking [%s] vs. [%s].", stagingDir, discDir)
             compareContents(stagingDir, discDir, verbose=True)
             logger.info("Consistency check completed for [%s].  No problems found.", stagingDir)
@@ -374,15 +374,15 @@ def _findCorrectDailyDir(options, config
     todayDate = today.strftime(DIR_TIME_FORMAT)
     yesterdayDate = yesterday.strftime(DIR_TIME_FORMAT)
     tomorrowDate = tomorrow.strftime(DIR_TIME_FORMAT)
-    todayPath = os.path.join(config.stage.targetDir, todayDate)
-    yesterdayPath = os.path.join(config.stage.targetDir, yesterdayDate)
-    tomorrowPath = os.path.join(config.stage.targetDir, tomorrowDate)
-    todayStageInd = os.path.join(todayPath, STAGE_INDICATOR)
-    yesterdayStageInd = os.path.join(yesterdayPath, STAGE_INDICATOR)
-    tomorrowStageInd = os.path.join(tomorrowPath, STAGE_INDICATOR)
-    todayStoreInd = os.path.join(todayPath, STORE_INDICATOR)
-    yesterdayStoreInd = os.path.join(yesterdayPath, STORE_INDICATOR)
-    tomorrowStoreInd = os.path.join(tomorrowPath, STORE_INDICATOR)
+    todayPath = pathJoin(config.stage.targetDir, todayDate)
+    yesterdayPath = pathJoin(config.stage.targetDir, yesterdayDate)
+    tomorrowPath = pathJoin(config.stage.targetDir, tomorrowDate)
+    todayStageInd = pathJoin(todayPath, STAGE_INDICATOR)
+    yesterdayStageInd = pathJoin(yesterdayPath, STAGE_INDICATOR)
+    tomorrowStageInd = pathJoin(tomorrowPath, STAGE_INDICATOR)
+    todayStoreInd = pathJoin(todayPath, STORE_INDICATOR)
+    yesterdayStoreInd = pathJoin(yesterdayPath, STORE_INDICATOR)
+    tomorrowStoreInd = pathJoin(tomorrowPath, STORE_INDICATOR)
     if options.full:
         if os.path.isdir(todayPath) and os.path.exists(todayStageInd):
             logger.info("Store process will use current day's stage directory [%s]", todayPath)
diff -pruN 3.5.4-1/src/CedarBackup3/actions/util.py 3.6.0-1/src/CedarBackup3/actions/util.py
--- 3.5.4-1/src/CedarBackup3/actions/util.py	2021-01-17 21:04:43.000000000 +0000
+++ 3.6.0-1/src/CedarBackup3/actions/util.py	2021-02-03 20:03:27.000000000 +0000
@@ -53,7 +53,7 @@ import time
 from CedarBackup3.actions.constants import INDICATOR_PATTERN
 from CedarBackup3.config import DEFAULT_DEVICE_TYPE, DEFAULT_MEDIA_TYPE, REWRITABLE_MEDIA_TYPES
 from CedarBackup3.filesystem import FilesystemList
-from CedarBackup3.util import changeOwnership, deviceMounted
+from CedarBackup3.util import changeOwnership, deviceMounted, pathJoin
 from CedarBackup3.writers.cdwriter import MEDIA_CDR_74, MEDIA_CDR_80, MEDIA_CDRW_74, MEDIA_CDRW_80, CdWriter
 from CedarBackup3.writers.dvdwriter import MEDIA_DVDPLUSR, MEDIA_DVDPLUSRW, DvdWriter
 from CedarBackup3.writers.util import readMediaLabel
@@ -98,7 +98,7 @@ def findDailyDirs(stagingDir, indicatorF
             dailyDirs.excludeLinks = True
             dailyDirs.addDirContents(path=monthDir, recursive=False, addSelf=False)
             for dailyDir in dailyDirs:
-                if os.path.exists(os.path.join(dailyDir, indicatorFile)):
+                if os.path.exists(pathJoin(dailyDir, indicatorFile)):
                     logger.debug("Skipping directory [%s]; contains %s.", dailyDir, indicatorFile)
                 else:
                     logger.debug("Adding [%s] to list of daily directories.", dailyDir)
@@ -172,7 +172,7 @@ def writeIndicatorFile(targetDir, indica
     Raises:
        IOException: If there is a problem writing the indicator file
     """
-    filename = os.path.join(targetDir, indicatorFile)
+    filename = pathJoin(targetDir, indicatorFile)
     logger.debug("Writing indicator file [%s].", filename)
     try:
         with open(filename, "w") as f:
diff -pruN 3.5.4-1/src/CedarBackup3/cli.py 3.6.0-1/src/CedarBackup3/cli.py
--- 3.5.4-1/src/CedarBackup3/cli.py	2021-01-17 21:04:43.000000000 +0000
+++ 3.6.0-1/src/CedarBackup3/cli.py	2021-02-03 20:03:27.000000000 +0000
@@ -1230,7 +1230,7 @@ def _setupDiskFlowLogging(flowLogger, lo
        options: Command-line options
     """
     formatter = logging.Formatter(fmt=DISK_LOG_FORMAT, datefmt=DATE_FORMAT)
-    handler = logging.FileHandler(logfile, mode="a")
+    handler = logging.FileHandler(logfile, mode="a", encoding="utf-8")
     handler.setFormatter(formatter)
     if options.debug:
         handler.setLevel(logging.DEBUG)
@@ -1270,7 +1270,7 @@ def _setupDiskOutputLogging(outputLogger
        options: Command-line options
     """
     formatter = logging.Formatter(fmt=DISK_OUTPUT_FORMAT, datefmt=DATE_FORMAT)
-    handler = logging.FileHandler(logfile, mode="a")
+    handler = logging.FileHandler(logfile, mode="a", encoding="utf-8")
     handler.setFormatter(formatter)
     if options.debug or options.output:
         handler.setLevel(logging.DEBUG)
diff -pruN 3.5.4-1/src/CedarBackup3/extend/amazons3.py 3.6.0-1/src/CedarBackup3/extend/amazons3.py
--- 3.5.4-1/src/CedarBackup3/extend/amazons3.py	2021-01-17 21:04:43.000000000 +0000
+++ 3.6.0-1/src/CedarBackup3/extend/amazons3.py	2021-02-03 20:03:27.000000000 +0000
@@ -103,6 +103,7 @@ from CedarBackup3.util import (
     executeCommand,
     isRunningAsRoot,
     isStartOfWeek,
+    pathJoin,
     resolveCommand,
 )
 from CedarBackup3.xmlutil import (
@@ -637,15 +638,15 @@ def _findCorrectDailyDir(options, config
     todayDate = today.strftime(DIR_TIME_FORMAT)
     yesterdayDate = yesterday.strftime(DIR_TIME_FORMAT)
     tomorrowDate = tomorrow.strftime(DIR_TIME_FORMAT)
-    todayPath = os.path.join(config.stage.targetDir, todayDate)
-    yesterdayPath = os.path.join(config.stage.targetDir, yesterdayDate)
-    tomorrowPath = os.path.join(config.stage.targetDir, tomorrowDate)
-    todayStageInd = os.path.join(todayPath, STAGE_INDICATOR)
-    yesterdayStageInd = os.path.join(yesterdayPath, STAGE_INDICATOR)
-    tomorrowStageInd = os.path.join(tomorrowPath, STAGE_INDICATOR)
-    todayStoreInd = os.path.join(todayPath, STORE_INDICATOR)
-    yesterdayStoreInd = os.path.join(yesterdayPath, STORE_INDICATOR)
-    tomorrowStoreInd = os.path.join(tomorrowPath, STORE_INDICATOR)
+    todayPath = pathJoin(config.stage.targetDir, todayDate)
+    yesterdayPath = pathJoin(config.stage.targetDir, yesterdayDate)
+    tomorrowPath = pathJoin(config.stage.targetDir, tomorrowDate)
+    todayStageInd = pathJoin(todayPath, STAGE_INDICATOR)
+    yesterdayStageInd = pathJoin(yesterdayPath, STAGE_INDICATOR)
+    tomorrowStageInd = pathJoin(tomorrowPath, STAGE_INDICATOR)
+    todayStoreInd = pathJoin(todayPath, STORE_INDICATOR)
+    yesterdayStoreInd = pathJoin(yesterdayPath, STORE_INDICATOR)
+    tomorrowStoreInd = pathJoin(tomorrowPath, STORE_INDICATOR)
     if options.full:
         if os.path.isdir(todayPath) and os.path.exists(todayStageInd):
             logger.info("Amazon S3 process will use current day's staging directory [%s]", todayPath)
diff -pruN 3.5.4-1/src/CedarBackup3/extend/mbox.py 3.6.0-1/src/CedarBackup3/extend/mbox.py
--- 3.5.4-1/src/CedarBackup3/extend/mbox.py	2021-01-17 21:04:43.000000000 +0000
+++ 3.6.0-1/src/CedarBackup3/extend/mbox.py	2021-02-03 20:03:27.000000000 +0000
@@ -108,6 +108,7 @@ from CedarBackup3.util import (
     encodePath,
     executeCommand,
     isStartOfWeek,
+    pathJoin,
     resolveCommand,
 )
 from CedarBackup3.xmlutil import (
@@ -1247,7 +1248,7 @@ def _getRevisionPath(config, item):
     """
     normalized = buildNormalizedPath(item.absolutePath)
     filename = "%s.%s" % (normalized, REVISION_PATH_EXTENSION)
-    revisionPath = os.path.join(config.options.workingDir, filename)
+    revisionPath = pathJoin(config.options.workingDir, filename)
     logger.debug("Revision file path is [%s]", revisionPath)
     return revisionPath
 
@@ -1343,7 +1344,7 @@ def _getExclusions(mboxDir):
     paths = []
     if mboxDir.relativeExcludePaths is not None:
         for relativePath in mboxDir.relativeExcludePaths:
-            paths.append(os.path.join(mboxDir.absolutePath, relativePath))
+            paths.append(pathJoin(mboxDir.absolutePath, relativePath))
     patterns = []
     if mboxDir.excludePatterns is not None:
         patterns.extend(mboxDir.excludePatterns)
@@ -1385,9 +1386,9 @@ def _getBackupPath(config, mboxPath, com
     elif compressMode == "bzip2":
         filename = "%s.bz2" % filename
     if targetDir is None:
-        backupPath = os.path.join(config.collect.targetDir, filename)
+        backupPath = pathJoin(config.collect.targetDir, filename)
     else:
-        backupPath = os.path.join(targetDir, filename)
+        backupPath = pathJoin(targetDir, filename)
     logger.debug("Backup file path is [%s]", backupPath)
     return backupPath
 
@@ -1424,7 +1425,7 @@ def _getTarfilePath(config, mboxPath, co
         archiveMode = "tarbz2"
     else:
         archiveMode = "tar"
-    tarfilePath = os.path.join(config.collect.targetDir, filename)
+    tarfilePath = pathJoin(config.collect.targetDir, filename)
     logger.debug("Tarfile path is [%s]", tarfilePath)
     return (tarfilePath, archiveMode)
 
diff -pruN 3.5.4-1/src/CedarBackup3/extend/mysql.py 3.6.0-1/src/CedarBackup3/extend/mysql.py
--- 3.5.4-1/src/CedarBackup3/extend/mysql.py	2021-01-17 21:04:43.000000000 +0000
+++ 3.6.0-1/src/CedarBackup3/extend/mysql.py	2021-02-03 20:03:27.000000000 +0000
@@ -92,7 +92,7 @@ from functools import total_ordering
 from gzip import GzipFile
 
 from CedarBackup3.config import VALID_COMPRESS_MODES
-from CedarBackup3.util import ObjectTypeList, changeOwnership, executeCommand, resolveCommand
+from CedarBackup3.util import ObjectTypeList, changeOwnership, executeCommand, pathJoin, resolveCommand
 from CedarBackup3.xmlutil import (
     addBooleanNode,
     addContainerNode,
@@ -652,9 +652,9 @@ def _getOutputFile(targetDir, database,
         Tuple of (Output file object, filename), file opened in binary mode for use with executeCommand()
     """
     if database is None:
-        filename = os.path.join(targetDir, "mysqldump.txt")
+        filename = pathJoin(targetDir, "mysqldump.txt")
     else:
-        filename = os.path.join(targetDir, "mysqldump-%s.txt" % database)
+        filename = pathJoin(targetDir, "mysqldump-%s.txt" % database)
     if compressMode == "gzip":
         filename = "%s.gz" % filename
         outputFile = GzipFile(filename, "wb")
diff -pruN 3.5.4-1/src/CedarBackup3/extend/postgresql.py 3.6.0-1/src/CedarBackup3/extend/postgresql.py
--- 3.5.4-1/src/CedarBackup3/extend/postgresql.py	2021-01-17 21:04:43.000000000 +0000
+++ 3.6.0-1/src/CedarBackup3/extend/postgresql.py	2021-02-03 20:03:27.000000000 +0000
@@ -82,7 +82,7 @@ from functools import total_ordering
 from gzip import GzipFile
 
 from CedarBackup3.config import VALID_COMPRESS_MODES
-from CedarBackup3.util import ObjectTypeList, changeOwnership, executeCommand, resolveCommand
+from CedarBackup3.util import ObjectTypeList, changeOwnership, executeCommand, pathJoin, resolveCommand
 from CedarBackup3.xmlutil import (
     addBooleanNode,
     addContainerNode,
@@ -615,9 +615,9 @@ def _getOutputFile(targetDir, database,
         Tuple of (Output file object, filename), file opened in binary mode for use with executeCommand()
     """
     if database is None:
-        filename = os.path.join(targetDir, "postgresqldump.txt")
+        filename = pathJoin(targetDir, "postgresqldump.txt")
     else:
-        filename = os.path.join(targetDir, "postgresqldump-%s.txt" % database)
+        filename = pathJoin(targetDir, "postgresqldump-%s.txt" % database)
     if compressMode == "gzip":
         filename = "%s.gz" % filename
         outputFile = GzipFile(filename, "wb")
diff -pruN 3.5.4-1/src/CedarBackup3/extend/subversion.py 3.6.0-1/src/CedarBackup3/extend/subversion.py
--- 3.5.4-1/src/CedarBackup3/extend/subversion.py	2021-01-17 21:04:43.000000000 +0000
+++ 3.6.0-1/src/CedarBackup3/extend/subversion.py	2021-02-03 20:03:27.000000000 +0000
@@ -87,6 +87,7 @@ from CedarBackup3.util import (
     encodePath,
     executeCommand,
     isStartOfWeek,
+    pathJoin,
     resolveCommand,
 )
 from CedarBackup3.xmlutil import (
@@ -1264,7 +1265,7 @@ def _getRevisionPath(config, repository)
     """
     normalized = buildNormalizedPath(repository.repositoryPath)
     filename = "%s.%s" % (normalized, REVISION_PATH_EXTENSION)
-    revisionPath = os.path.join(config.options.workingDir, filename)
+    revisionPath = pathJoin(config.options.workingDir, filename)
     logger.debug("Revision file path is [%s]", revisionPath)
     return revisionPath
 
@@ -1287,7 +1288,7 @@ def _getBackupPath(config, repositoryPat
         filename = "%s.gz" % filename
     elif compressMode == "bzip2":
         filename = "%s.bz2" % filename
-    backupPath = os.path.join(config.collect.targetDir, filename)
+    backupPath = pathJoin(config.collect.targetDir, filename)
     logger.debug("Backup file path is [%s]", backupPath)
     return backupPath
 
@@ -1329,7 +1330,7 @@ def _getExclusions(repositoryDir):
     paths = []
     if repositoryDir.relativeExcludePaths is not None:
         for relativePath in repositoryDir.relativeExcludePaths:
-            paths.append(os.path.join(repositoryDir.directoryPath, relativePath))
+            paths.append(pathJoin(repositoryDir.directoryPath, relativePath))
     patterns = []
     if repositoryDir.excludePatterns is not None:
         patterns.extend(repositoryDir.excludePatterns)
diff -pruN 3.5.4-1/src/CedarBackup3/extend/sysinfo.py 3.6.0-1/src/CedarBackup3/extend/sysinfo.py
--- 3.5.4-1/src/CedarBackup3/extend/sysinfo.py	2021-01-17 21:04:43.000000000 +0000
+++ 3.6.0-1/src/CedarBackup3/extend/sysinfo.py	2021-02-03 20:03:27.000000000 +0000
@@ -68,7 +68,7 @@ import logging
 import os
 from bz2 import BZ2File
 
-from CedarBackup3.util import changeOwnership, executeCommand, resolveCommand
+from CedarBackup3.util import changeOwnership, executeCommand, pathJoin, resolveCommand
 
 ########################################################################
 # Module-wide constants and variables
@@ -204,7 +204,7 @@ def _getOutputFile(targetDir, name, comp
     Returns:
         Tuple of (Output file object, filename), file opened in binary mode for use with executeCommand()
     """
-    filename = os.path.join(targetDir, "%s.txt" % name)
+    filename = pathJoin(targetDir, "%s.txt" % name)
     if compress:
         filename = "%s.bz2" % filename
     logger.debug("Dump file will be [%s].", filename)
diff -pruN 3.5.4-1/src/CedarBackup3/filesystem.py 3.6.0-1/src/CedarBackup3/filesystem.py
--- 3.5.4-1/src/CedarBackup3/filesystem.py	2021-01-17 21:04:43.000000000 +0000
+++ 3.6.0-1/src/CedarBackup3/filesystem.py	2021-02-03 20:03:27.000000000 +0000
@@ -61,6 +61,7 @@ from CedarBackup3.util import (
     dereferenceLink,
     displayBytes,
     encodePath,
+    pathJoin,
     removeKeys,
 )
 
@@ -294,6 +295,7 @@ class FilesystemList(list):
            ValueError: If the path could not be encoded properly
         """
         path = encodePath(path)
+        path = normalizeFile(path)
         if not os.path.exists(path) or not os.path.isfile(path):
             logger.debug("Path [%s] is not a file or does not exist on disk.", path)
             raise ValueError("Path is not a file or does not exist on disk.")
@@ -473,13 +475,13 @@ class FilesystemList(list):
             if re.compile(r"^%s$" % pattern).match(os.path.basename(path)):
                 logger.debug("Path [%s] is excluded based on basename pattern [%s].", path, pattern)
                 return added
-        if self.ignoreFile is not None and os.path.exists(os.path.join(path, self.ignoreFile)):
+        if self.ignoreFile is not None and os.path.exists(pathJoin(path, self.ignoreFile)):
             logger.debug("Path [%s] is excluded based on ignore file.", path)
             return added
         if includePath:
             added += self.addDir(path)  # could actually be excluded by addDir, yet
         for entry in os.listdir(path):
-            entrypath = os.path.join(path, entry)
+            entrypath = pathJoin(path, entry)
             if os.path.isfile(entrypath):
                 if linkDepth > 0 and dereference:
                     derefpath = dereferenceLink(entrypath)
@@ -1426,6 +1428,29 @@ class PurgeItemList(FilesystemList):  #
 # Public functions
 ########################################################################
 
+###########################
+# normalizeFile() function
+###########################
+
+
+def normalizeFile(path):
+    """
+    Normalizes a file name.
+
+    On Windows in particular, we often end up with mixed slashes, where
+    parts of a path have forward slash and parts have backward slash.
+    This makes it difficult to construct exclusions in configuration,
+    because you never know what part of a path will have what kind of
+    slash.  I've decided to standardize on forward slashes.
+
+    Args:
+       path (String representing a path on disk): Path to be normalized
+    Returns:
+        Normalized path, which should be equivalent to the original
+    """
+    return path.replace("\\", "/")
+
+
 ##########################
 # normalizeDir() function
 ##########################
@@ -1440,6 +1465,12 @@ def normalizeDir(path):
     appear within lists in a consistent way, although from the user's
     perspective passing in ``/path/to/dir/`` and ``/path/to/dir`` are equivalent.
 
+    We also convert slashes.  On Windows in particular, we often end up with
+    mixed slashes, where parts of a path have forward slash and parts have
+    backward slash.  This makes it difficult to construct exclusions in
+    configuration, because you never know what part of a path will have
+    what kind of slash.  I've decided to standardize on forward slashes.
+
     Args:
        path (String representing a path on disk): Path to be normalized
     Returns:
@@ -1447,7 +1478,7 @@ def normalizeDir(path):
     """
     if path != os.sep and path[-1:] == os.sep:
         return path[:-1]
-    return path
+    return path.replace("\\", "/")
 
 
 #############################
diff -pruN 3.5.4-1/src/CedarBackup3/peer.py 3.6.0-1/src/CedarBackup3/peer.py
--- 3.5.4-1/src/CedarBackup3/peer.py	2021-01-17 21:04:43.000000000 +0000
+++ 3.6.0-1/src/CedarBackup3/peer.py	2021-02-03 20:03:27.000000000 +0000
@@ -60,7 +60,7 @@ import sys
 
 from CedarBackup3.config import VALID_FAILURE_MODES
 from CedarBackup3.filesystem import FilesystemList
-from CedarBackup3.util import encodePath, executeCommand, isRunningAsRoot, resolveCommand, splitCommandLine
+from CedarBackup3.util import encodePath, executeCommand, isRunningAsRoot, pathJoin, resolveCommand, splitCommandLine
 
 ########################################################################
 # Module-wide constants and variables
@@ -261,9 +261,9 @@ class LocalPeer(object):
         """
         collectIndicator = encodePath(collectIndicator)
         if collectIndicator is None:
-            return os.path.exists(os.path.join(self.collectDir, DEF_COLLECT_INDICATOR))
+            return os.path.exists(pathJoin(self.collectDir, DEF_COLLECT_INDICATOR))
         else:
-            return os.path.exists(os.path.join(self.collectDir, collectIndicator))
+            return os.path.exists(pathJoin(self.collectDir, collectIndicator))
 
     def writeStageIndicator(self, stageIndicator=None, ownership=None, permissions=None):
         """
@@ -294,9 +294,9 @@ class LocalPeer(object):
             logger.debug("Collect directory [%s] is not a directory or does not exist on disk.", self.collectDir)
             raise ValueError("Collect directory is not a directory or does not exist on disk.")
         if stageIndicator is None:
-            fileName = os.path.join(self.collectDir, DEF_STAGE_INDICATOR)
+            fileName = pathJoin(self.collectDir, DEF_STAGE_INDICATOR)
         else:
-            fileName = os.path.join(self.collectDir, stageIndicator)
+            fileName = pathJoin(self.collectDir, stageIndicator)
         LocalPeer._copyLocalFile(None, fileName, ownership, permissions)  # None for sourceFile results in an empty target
 
     ##################
@@ -335,8 +335,8 @@ class LocalPeer(object):
         sourceDir = encodePath(sourceDir)
         targetDir = encodePath(targetDir)
         for fileName in os.listdir(sourceDir):
-            sourceFile = os.path.join(sourceDir, fileName)
-            targetFile = os.path.join(targetDir, fileName)
+            sourceFile = pathJoin(sourceDir, fileName)
+            targetFile = pathJoin(targetDir, fileName)
             LocalPeer._copyLocalFile(sourceFile, targetFile, ownership, permissions)
             filesCopied += 1
         return filesCopied
@@ -792,12 +792,12 @@ class RemotePeer(object):
         """
         try:
             if collectIndicator is None:
-                sourceFile = os.path.join(self.collectDir, DEF_COLLECT_INDICATOR)
-                targetFile = os.path.join(self.workingDir, DEF_COLLECT_INDICATOR)
+                sourceFile = pathJoin(self.collectDir, DEF_COLLECT_INDICATOR)
+                targetFile = pathJoin(self.workingDir, DEF_COLLECT_INDICATOR)
             else:
                 collectIndicator = encodePath(collectIndicator)
-                sourceFile = os.path.join(self.collectDir, collectIndicator)
-                targetFile = os.path.join(self.workingDir, collectIndicator)
+                sourceFile = pathJoin(self.collectDir, collectIndicator)
+                targetFile = pathJoin(self.workingDir, collectIndicator)
             logger.debug("Fetch remote [%s] into [%s].", sourceFile, targetFile)
             if os.path.exists(targetFile):
                 try:
@@ -852,11 +852,11 @@ class RemotePeer(object):
         """
         stageIndicator = encodePath(stageIndicator)
         if stageIndicator is None:
-            sourceFile = os.path.join(self.workingDir, DEF_STAGE_INDICATOR)
-            targetFile = os.path.join(self.collectDir, DEF_STAGE_INDICATOR)
+            sourceFile = pathJoin(self.workingDir, DEF_STAGE_INDICATOR)
+            targetFile = pathJoin(self.collectDir, DEF_STAGE_INDICATOR)
         else:
-            sourceFile = os.path.join(self.workingDir, DEF_STAGE_INDICATOR)
-            targetFile = os.path.join(self.collectDir, stageIndicator)
+            sourceFile = pathJoin(self.workingDir, DEF_STAGE_INDICATOR)
+            targetFile = pathJoin(self.collectDir, stageIndicator)
         try:
             if not os.path.exists(sourceFile):
                 with open(sourceFile, "w") as f:
diff -pruN 3.5.4-1/src/CedarBackup3/release.py 3.6.0-1/src/CedarBackup3/release.py
--- 3.5.4-1/src/CedarBackup3/release.py	2021-01-17 21:04:43.000000000 +0000
+++ 3.6.0-1/src/CedarBackup3/release.py	2021-02-03 20:03:27.000000000 +0000
@@ -35,6 +35,6 @@ Attributes:
 AUTHOR = "Kenneth J. Pronovici"
 EMAIL = "pronovic@ieee.org"
 COPYRIGHT = "2004-2021"
-VERSION = "3.5.4"
-DATE = "17 Jan 2021"
+VERSION = "3.6.0"
+DATE = "03 Feb 2021"
 URL = "https://github.com/pronovic/cedar-backup3"
diff -pruN 3.5.4-1/src/CedarBackup3/testutil.py 3.6.0-1/src/CedarBackup3/testutil.py
--- 3.5.4-1/src/CedarBackup3/testutil.py	2021-01-17 21:04:43.000000000 +0000
+++ 3.6.0-1/src/CedarBackup3/testutil.py	2021-02-03 20:03:27.000000000 +0000
@@ -70,7 +70,7 @@ from io import StringIO
 from CedarBackup3.cli import setupPathResolver
 from CedarBackup3.config import Config, OptionsConfig
 from CedarBackup3.customize import customizeOverrides
-from CedarBackup3.util import encodePath, executeCommand, nullDevice
+from CedarBackup3.util import encodePath, executeCommand, nullDevice, pathJoin
 
 ########################################################################
 # Public functions
@@ -158,7 +158,7 @@ def findResources(resources, dataDirs):
     mapping = {}
     for resource in resources:
         for resourceDir in dataDirs:
-            path = os.path.join(resourceDir, resource)
+            path = pathJoin(resourceDir, resource)
             if os.path.exists(path):
                 mapping[resource] = path
                 break
@@ -183,7 +183,7 @@ def commandAvailable(command):
     """
     if "PATH" in os.environ:
         for path in os.environ["PATH"].split(os.sep):
-            if os.path.exists(os.path.join(path, command)):
+            if os.path.exists(pathJoin(path, command)):
                 return True
     return False
 
@@ -206,7 +206,7 @@ def buildPath(components):
     """
     path = components[0]
     for component in components[1:]:
-        path = os.path.join(path, component)
+        path = pathJoin(path, component)
     return encodePath(path)
 
 
@@ -227,13 +227,13 @@ def removedir(tree):
     tree = encodePath(tree)
     for root, dirs, files in os.walk(tree, topdown=False):
         for name in files:
-            path = os.path.join(root, name)
+            path = pathJoin(root, name)
             if os.path.islink(path):
                 os.remove(path)
             elif os.path.isfile(path):
                 os.remove(path)
         for name in dirs:
-            path = os.path.join(root, name)
+            path = pathJoin(root, name)
             if os.path.islink(path):
                 os.remove(path)
             elif os.path.isdir(path):
diff -pruN 3.5.4-1/src/CedarBackup3/util.py 3.6.0-1/src/CedarBackup3/util.py
--- 3.5.4-1/src/CedarBackup3/util.py	2021-01-17 21:04:43.000000000 +0000
+++ 3.6.0-1/src/CedarBackup3/util.py	2021-02-03 20:03:27.000000000 +0000
@@ -1818,6 +1818,27 @@ def encodePath(path):
         raise ValueError("Path could not be safely encoded as %s: %s" % (encoding, str(e)))
 
 
+######################
+# pathJoin() function
+######################
+
+
+def pathJoin(path, *paths):
+    """
+    Wraps os.path.join(), normalizing slashes in the result.
+
+    On Windows in particular, we often end up with mixed slashes, where parts of a path
+    have forward slash and parts have backward slash.  This makes it difficult to construct
+    exclusions in configuration, because you never know what part of a path will have
+    what kind of slash.  I've decided to standardize on forward slashes.
+
+    Returns:
+        Result as from os.path.join() but always with forward slashes.
+    """
+    result = os.path.join(path, *paths)
+    return result.replace("\\", "/")
+
+
 ########################
 # nullDevice() function
 ########################
@@ -1904,8 +1925,9 @@ def buildNormalizedPath(path):
     A normalized path is a representation of a path that is also a valid file
     name.  To make a valid file name out of a complete path, we have to convert
     or remove some characters that are significant to the filesystem -- in
-    particular, the path separator and any leading ``'.'`` character (which would
-    cause the file to be hidden in a file listing).
+    particular, the path separator, the Windows drive separator, and any
+    leading ``'.'`` character (which would cause the file to be hidden in
+    a file listing).
 
     Note that this is a one-way transformation -- you can't safely derive the
     original path from the normalized path.
@@ -1914,10 +1936,16 @@ def buildNormalizedPath(path):
     first character is ``'/'`` or ``'\\'``, it gets removed.  If the first
     character is ``'.'``, it gets converted to ``'_'``.  Then, we look through the
     rest of the path and convert all remaining ``'/'`` or ``'\\'`` characters
-    ``'-'``, and all remaining whitespace characters to ``'_'``.
+    ``'-'``, and all remaining whitespace or ``':'`` characters to ``'_'``.
 
     As a special case, a path consisting only of a single ``'/'`` or ``'\\'``
-    character will be converted to ``'-'``.
+    character will be converted to ``'_'``.  That's better than ``'-'``, because
+    a dash tends to get interpreted by shell commands as a switch.
+
+    As a special case, anything that looks like a leading Windows drive letter
+    combination (like ``c:\\`` or ``c:/``) will be converted to something like
+    ``c-``.  This is needed because a colon isn't a valid filename character
+    on Windows.
 
     Args:
        path: Path to normalize
@@ -1933,15 +1961,17 @@ def buildNormalizedPath(path):
     elif len(path) == 0:
         return path
     elif path == "/" or path == "\\":
-        return "-"
+        return "_"
     else:
         normalized = path
+        normalized = re.sub(r"(^[A-Za-z])(:)([\\/])", r"\1-", normalized)  # normalize Windows drive letter
         normalized = re.sub(r"^/", "", normalized)  # remove leading '/'
         normalized = re.sub(r"^\\", "", normalized)  # remove leading '\'
         normalized = re.sub(r"^\.", "_", normalized)  # convert leading '.' to '_' so file won't be hidden
         normalized = re.sub(r"/", "-", normalized)  # convert all '/' characters to '-'
         normalized = re.sub(r"\\", "-", normalized)  # convert all '\' characters to '-'
         normalized = re.sub(r"\s", "_", normalized)  # convert all whitespace to '_'
+        normalized = re.sub(r":", "_", normalized)  # convert all remaining colons to '_'
         return normalized
 
 
diff -pruN 3.5.4-1/src/CedarBackup3/writers/util.py 3.6.0-1/src/CedarBackup3/writers/util.py
--- 3.5.4-1/src/CedarBackup3/writers/util.py	2021-01-17 21:04:43.000000000 +0000
+++ 3.6.0-1/src/CedarBackup3/writers/util.py	2021-02-03 20:03:27.000000000 +0000
@@ -49,7 +49,7 @@ import logging
 import os
 import re
 
-from CedarBackup3.util import UNIT_BYTES, UNIT_SECTORS, convertSize, encodePath, executeCommand, resolveCommand
+from CedarBackup3.util import UNIT_BYTES, UNIT_SECTORS, convertSize, encodePath, executeCommand, pathJoin, resolveCommand
 
 ########################################################################
 # Module-wide constants and variables
@@ -530,12 +530,12 @@ class IsoImage(object):
                 if contentsOnly:
                     self.entries[path] = graftPoint
                 else:
-                    self.entries[path] = os.path.join(graftPoint, os.path.basename(path))
+                    self.entries[path] = pathJoin(graftPoint, os.path.basename(path))
             elif self.graftPoint is not None:
                 if contentsOnly:
                     self.entries[path] = self.graftPoint
                 else:
-                    self.entries[path] = os.path.join(self.graftPoint, os.path.basename(path))
+                    self.entries[path] = pathJoin(self.graftPoint, os.path.basename(path))
             else:
                 if contentsOnly:
                     self.entries[path] = None
diff -pruN 3.5.4-1/tests/test_filesystem.py 3.6.0-1/tests/test_filesystem.py
--- 3.5.4-1/tests/test_filesystem.py	2021-01-17 21:04:43.000000000 +0000
+++ 3.6.0-1/tests/test_filesystem.py	2021-02-03 20:03:27.000000000 +0000
@@ -113,7 +113,7 @@ from CedarBackup3.testutil import (
     randomFilename,
     removedir,
 )
-from CedarBackup3.util import encodePath
+from CedarBackup3.util import encodePath, pathJoin
 
 #######################################################################
 # Module-wide configuration and constants
@@ -20257,7 +20257,7 @@ class TestFunctions(unittest.TestCase):
         if within is None:
             extractTar(self.tmpdir, self.resources["%s.tar.gz" % tarname])
         else:
-            path = os.path.join(self.tmpdir, within)
+            path = pathJoin(self.tmpdir, within)
             os.mkdir(path)
             extractTar(path, self.resources["%s.tar.gz" % tarname])
 
diff -pruN 3.5.4-1/tests/test_peer.py 3.6.0-1/tests/test_peer.py
--- 3.5.4-1/tests/test_peer.py	2021-01-17 21:04:43.000000000 +0000
+++ 3.6.0-1/tests/test_peer.py	2021-02-03 20:03:27.000000000 +0000
@@ -106,7 +106,7 @@ from CedarBackup3.testutil import (
     platformWindows,
     removedir,
 )
-from CedarBackup3.util import isRunningAsRoot
+from CedarBackup3.util import isRunningAsRoot, pathJoin
 
 #######################################################################
 # Module-wide configuration and constants
@@ -715,8 +715,8 @@ class TestRemotePeer(unittest.TestCase):
             from CedarBackup3.util import PathResolverSingleton
 
             mapping = {}
-            mapping["/usr/bin/ssh"] = os.path.join(os.environ["HOME"], "util", "ssh")
-            mapping["/usr/bin/scp"] = os.path.join(os.environ["HOME"], "util", "scp")
+            mapping["/usr/bin/ssh"] = pathJoin(os.environ["HOME"], "util", "ssh")
+            mapping["/usr/bin/scp"] = pathJoin(os.environ["HOME"], "util", "scp")
             singleton = PathResolverSingleton.getInstance()
             singleton.fill(mapping)
 
diff -pruN 3.5.4-1/tests/test_split.py 3.6.0-1/tests/test_split.py
--- 3.5.4-1/tests/test_split.py	2021-01-17 21:04:43.000000000 +0000
+++ 3.6.0-1/tests/test_split.py	2021-02-03 20:03:27.000000000 +0000
@@ -112,7 +112,7 @@ from CedarBackup3.testutil import (
     findResources,
     removedir,
 )
-from CedarBackup3.util import UNIT_BYTES, UNIT_GBYTES, UNIT_KBYTES, UNIT_MBYTES
+from CedarBackup3.util import UNIT_BYTES, UNIT_GBYTES, UNIT_KBYTES, UNIT_MBYTES, pathJoin
 from CedarBackup3.xmlutil import createOutputDom, serializeDom
 
 #######################################################################
@@ -912,27 +912,27 @@ class TestFunctions(unittest.TestCase):
         self.extractTar("tree21")
         dailyDir = self.buildPath(["tree21", "2007", "01", "01"])
         self.assertTrue(os.path.exists(dailyDir) and os.path.isdir(dailyDir))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system1", "file001.a.b")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system1", "file002")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system1", "file003")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system2", "file001")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system2", "file002")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system2", "file003")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system3", "file001")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system3", "file002")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system3", "file003")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system1", "file001.a.b")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system1", "file002")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system1", "file003")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system2", "file001")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system2", "file002")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system2", "file003")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system3", "file001")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system3", "file002")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system3", "file003")))
         sizeLimit = ByteQuantity("1.0", UNIT_MBYTES)
         splitSize = ByteQuantity("100000", UNIT_BYTES)
         _splitDailyDir(dailyDir, sizeLimit, splitSize, None, None)
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system1", "file001.a.b")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system1", "file002")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system1", "file003")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system2", "file001")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system2", "file002")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system2", "file003")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system3", "file001")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system3", "file002")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system3", "file003")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system1", "file001.a.b")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system1", "file002")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system1", "file003")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system2", "file001")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system2", "file002")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system2", "file003")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system3", "file001")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system3", "file002")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system3", "file003")))
 
     def testSplitDailyDir_003(self):
         """
@@ -941,29 +941,29 @@ class TestFunctions(unittest.TestCase):
         self.extractTar("tree21")
         dailyDir = self.buildPath(["tree21", "2007", "01", "01"])
         self.assertTrue(os.path.exists(dailyDir) and os.path.isdir(dailyDir))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system1", "file001.a.b")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system1", "file002")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system1", "file003")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system2", "file001")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system2", "file002")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system2", "file003")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system3", "file001")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system3", "file002")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system3", "file003")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system1", "file001.a.b")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system1", "file002")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system1", "file003")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system2", "file001")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system2", "file002")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system2", "file003")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system3", "file001")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system3", "file002")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system3", "file003")))
         sizeLimit = ByteQuantity("100000", UNIT_BYTES)
         splitSize = ByteQuantity("10", UNIT_KBYTES)
         _splitDailyDir(dailyDir, sizeLimit, splitSize, None, None)
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system1", "file001.a.b")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system1", "file002")))
-        self.assertFalse(os.path.exists(os.path.join(dailyDir, "system1", "file003")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system2", "file001")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system2", "file002")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system2", "file003")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system3", "file001")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system3", "file002")))
-        self.assertFalse(os.path.exists(os.path.join(dailyDir, "system3", "file003")))
-        self.checkSplit(os.path.join(dailyDir, "system1", "file003"), 320000, 10 * 1024)
-        self.checkSplit(os.path.join(dailyDir, "system3", "file003"), 100001, 10 * 1024)
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system1", "file001.a.b")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system1", "file002")))
+        self.assertFalse(os.path.exists(pathJoin(dailyDir, "system1", "file003")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system2", "file001")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system2", "file002")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system2", "file003")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system3", "file001")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system3", "file002")))
+        self.assertFalse(os.path.exists(pathJoin(dailyDir, "system3", "file003")))
+        self.checkSplit(pathJoin(dailyDir, "system1", "file003"), 320000, 10 * 1024)
+        self.checkSplit(pathJoin(dailyDir, "system3", "file003"), 100001, 10 * 1024)
 
     def testSplitDailyDir_004(self):
         """
@@ -972,31 +972,31 @@ class TestFunctions(unittest.TestCase):
         self.extractTar("tree21")
         dailyDir = self.buildPath(["tree21", "2007", "01", "01"])
         self.assertTrue(os.path.exists(dailyDir) and os.path.isdir(dailyDir))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system1", "file001.a.b")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system1", "file002")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system1", "file003")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system2", "file001")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system2", "file002")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system2", "file003")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system3", "file001")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system3", "file002")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system3", "file003")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system1", "file001.a.b")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system1", "file002")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system1", "file003")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system2", "file001")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system2", "file002")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system2", "file003")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system3", "file001")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system3", "file002")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system3", "file003")))
         sizeLimit = ByteQuantity("99999", UNIT_BYTES)
         splitSize = ByteQuantity("5000", UNIT_BYTES)
         _splitDailyDir(dailyDir, sizeLimit, splitSize, None, None)
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system1", "file001.a.b")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system1", "file002")))
-        self.assertFalse(os.path.exists(os.path.join(dailyDir, "system1", "file003")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system2", "file001")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system2", "file002")))
-        self.assertFalse(os.path.exists(os.path.join(dailyDir, "system2", "file003")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system3", "file001")))
-        self.assertFalse(os.path.exists(os.path.join(dailyDir, "system3", "file002")))
-        self.assertFalse(os.path.exists(os.path.join(dailyDir, "system3", "file003")))
-        self.checkSplit(os.path.join(dailyDir, "system1", "file003"), 320000, 5000)
-        self.checkSplit(os.path.join(dailyDir, "system2", "file003"), 100000, 5000)
-        self.checkSplit(os.path.join(dailyDir, "system3", "file002"), 100000, 5000)
-        self.checkSplit(os.path.join(dailyDir, "system3", "file003"), 100001, 5000)
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system1", "file001.a.b")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system1", "file002")))
+        self.assertFalse(os.path.exists(pathJoin(dailyDir, "system1", "file003")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system2", "file001")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system2", "file002")))
+        self.assertFalse(os.path.exists(pathJoin(dailyDir, "system2", "file003")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system3", "file001")))
+        self.assertFalse(os.path.exists(pathJoin(dailyDir, "system3", "file002")))
+        self.assertFalse(os.path.exists(pathJoin(dailyDir, "system3", "file003")))
+        self.checkSplit(pathJoin(dailyDir, "system1", "file003"), 320000, 5000)
+        self.checkSplit(pathJoin(dailyDir, "system2", "file003"), 100000, 5000)
+        self.checkSplit(pathJoin(dailyDir, "system3", "file002"), 100000, 5000)
+        self.checkSplit(pathJoin(dailyDir, "system3", "file003"), 100001, 5000)
 
     def testSplitDailyDir_005(self):
         """
@@ -1005,33 +1005,33 @@ class TestFunctions(unittest.TestCase):
         self.extractTar("tree21")
         dailyDir = self.buildPath(["tree21", "2007", "01", "01"])
         self.assertTrue(os.path.exists(dailyDir) and os.path.isdir(dailyDir))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system1", "file001.a.b")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system1", "file002")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system1", "file003")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system2", "file001")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system2", "file002")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system2", "file003")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system3", "file001")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system3", "file002")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system3", "file003")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system1", "file001.a.b")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system1", "file002")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system1", "file003")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system2", "file001")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system2", "file002")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system2", "file003")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system3", "file001")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system3", "file002")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system3", "file003")))
         sizeLimit = ByteQuantity("10000.0", UNIT_BYTES)
         splitSize = ByteQuantity("2500", UNIT_BYTES)
         _splitDailyDir(dailyDir, sizeLimit, splitSize, None, None)
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system1", "file001.a.b")))
-        self.assertFalse(os.path.exists(os.path.join(dailyDir, "system1", "file002")))
-        self.assertFalse(os.path.exists(os.path.join(dailyDir, "system1", "file003")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system2", "file001")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system2", "file002")))
-        self.assertFalse(os.path.exists(os.path.join(dailyDir, "system2", "file003")))
-        self.assertFalse(os.path.exists(os.path.join(dailyDir, "system3", "file001")))
-        self.assertFalse(os.path.exists(os.path.join(dailyDir, "system3", "file002")))
-        self.assertFalse(os.path.exists(os.path.join(dailyDir, "system3", "file003")))
-        self.checkSplit(os.path.join(dailyDir, "system1", "file002"), 32000, 2500)
-        self.checkSplit(os.path.join(dailyDir, "system1", "file003"), 320000, 2500)
-        self.checkSplit(os.path.join(dailyDir, "system2", "file003"), 100000, 2500)
-        self.checkSplit(os.path.join(dailyDir, "system3", "file001"), 99999, 2500)
-        self.checkSplit(os.path.join(dailyDir, "system3", "file002"), 100000, 2500)
-        self.checkSplit(os.path.join(dailyDir, "system3", "file003"), 100001, 2500)
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system1", "file001.a.b")))
+        self.assertFalse(os.path.exists(pathJoin(dailyDir, "system1", "file002")))
+        self.assertFalse(os.path.exists(pathJoin(dailyDir, "system1", "file003")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system2", "file001")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system2", "file002")))
+        self.assertFalse(os.path.exists(pathJoin(dailyDir, "system2", "file003")))
+        self.assertFalse(os.path.exists(pathJoin(dailyDir, "system3", "file001")))
+        self.assertFalse(os.path.exists(pathJoin(dailyDir, "system3", "file002")))
+        self.assertFalse(os.path.exists(pathJoin(dailyDir, "system3", "file003")))
+        self.checkSplit(pathJoin(dailyDir, "system1", "file002"), 32000, 2500)
+        self.checkSplit(pathJoin(dailyDir, "system1", "file003"), 320000, 2500)
+        self.checkSplit(pathJoin(dailyDir, "system2", "file003"), 100000, 2500)
+        self.checkSplit(pathJoin(dailyDir, "system3", "file001"), 99999, 2500)
+        self.checkSplit(pathJoin(dailyDir, "system3", "file002"), 100000, 2500)
+        self.checkSplit(pathJoin(dailyDir, "system3", "file003"), 100001, 2500)
 
     def testSplitDailyDir_006(self):
         """
@@ -1040,33 +1040,33 @@ class TestFunctions(unittest.TestCase):
         self.extractTar("tree21")
         dailyDir = self.buildPath(["tree21", "2007", "01", "01"])
         self.assertTrue(os.path.exists(dailyDir) and os.path.isdir(dailyDir))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system1", "file001.a.b")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system1", "file002")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system1", "file003")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system2", "file001")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system2", "file002")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system2", "file003")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system3", "file001")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system3", "file002")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system3", "file003")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system1", "file001.a.b")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system1", "file002")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system1", "file003")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system2", "file001")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system2", "file002")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system2", "file003")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system3", "file001")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system3", "file002")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system3", "file003")))
         sizeLimit = ByteQuantity("10000", UNIT_BYTES)
         splitSize = ByteQuantity("1.0", UNIT_KBYTES)
         _splitDailyDir(dailyDir, sizeLimit, splitSize, None, None)
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system1", "file001.a.b")))
-        self.assertFalse(os.path.exists(os.path.join(dailyDir, "system1", "file002")))
-        self.assertFalse(os.path.exists(os.path.join(dailyDir, "system1", "file003")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system2", "file001")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system2", "file002")))
-        self.assertFalse(os.path.exists(os.path.join(dailyDir, "system2", "file003")))
-        self.assertFalse(os.path.exists(os.path.join(dailyDir, "system3", "file001")))
-        self.assertFalse(os.path.exists(os.path.join(dailyDir, "system3", "file002")))
-        self.assertFalse(os.path.exists(os.path.join(dailyDir, "system3", "file003")))
-        self.checkSplit(os.path.join(dailyDir, "system1", "file002"), 32000, 1 * 1024)
-        self.checkSplit(os.path.join(dailyDir, "system1", "file003"), 320000, 1 * 1024)
-        self.checkSplit(os.path.join(dailyDir, "system2", "file003"), 100000, 1 * 1024)
-        self.checkSplit(os.path.join(dailyDir, "system3", "file001"), 99999, 1 * 1024)
-        self.checkSplit(os.path.join(dailyDir, "system3", "file002"), 100000, 1 * 1024)
-        self.checkSplit(os.path.join(dailyDir, "system3", "file003"), 100001, 1 * 1024)
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system1", "file001.a.b")))
+        self.assertFalse(os.path.exists(pathJoin(dailyDir, "system1", "file002")))
+        self.assertFalse(os.path.exists(pathJoin(dailyDir, "system1", "file003")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system2", "file001")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system2", "file002")))
+        self.assertFalse(os.path.exists(pathJoin(dailyDir, "system2", "file003")))
+        self.assertFalse(os.path.exists(pathJoin(dailyDir, "system3", "file001")))
+        self.assertFalse(os.path.exists(pathJoin(dailyDir, "system3", "file002")))
+        self.assertFalse(os.path.exists(pathJoin(dailyDir, "system3", "file003")))
+        self.checkSplit(pathJoin(dailyDir, "system1", "file002"), 32000, 1 * 1024)
+        self.checkSplit(pathJoin(dailyDir, "system1", "file003"), 320000, 1 * 1024)
+        self.checkSplit(pathJoin(dailyDir, "system2", "file003"), 100000, 1 * 1024)
+        self.checkSplit(pathJoin(dailyDir, "system3", "file001"), 99999, 1 * 1024)
+        self.checkSplit(pathJoin(dailyDir, "system3", "file002"), 100000, 1 * 1024)
+        self.checkSplit(pathJoin(dailyDir, "system3", "file003"), 100001, 1 * 1024)
 
     def testSplitDailyDir_007(self):
         """
@@ -1075,31 +1075,31 @@ class TestFunctions(unittest.TestCase):
         self.extractTar("tree21")
         dailyDir = self.buildPath(["tree21", "2007", "01", "01"])
         self.assertTrue(os.path.exists(dailyDir) and os.path.isdir(dailyDir))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system1", "file001.a.b")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system1", "file002")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system1", "file003")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system2", "file001")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system2", "file002")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system2", "file003")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system3", "file001")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system3", "file002")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system3", "file003")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system1", "file001.a.b")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system1", "file002")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system1", "file003")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system2", "file001")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system2", "file002")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system2", "file003")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system3", "file001")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system3", "file002")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system3", "file003")))
         sizeLimit = ByteQuantity("9999", UNIT_BYTES)
         splitSize = ByteQuantity("1000", UNIT_BYTES)
         _splitDailyDir(dailyDir, sizeLimit, splitSize, None, None)
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system1", "file001.a.b")))
-        self.assertFalse(os.path.exists(os.path.join(dailyDir, "system1", "file002")))
-        self.assertFalse(os.path.exists(os.path.join(dailyDir, "system1", "file003")))
-        self.assertTrue(os.path.exists(os.path.join(dailyDir, "system2", "file001")))
-        self.assertFalse(os.path.exists(os.path.join(dailyDir, "system2", "file002")))
-        self.assertFalse(os.path.exists(os.path.join(dailyDir, "system2", "file003")))
-        self.assertFalse(os.path.exists(os.path.join(dailyDir, "system3", "file001")))
-        self.assertFalse(os.path.exists(os.path.join(dailyDir, "system3", "file002")))
-        self.assertFalse(os.path.exists(os.path.join(dailyDir, "system3", "file003")))
-        self.checkSplit(os.path.join(dailyDir, "system1", "file002"), 32000, 1000)
-        self.checkSplit(os.path.join(dailyDir, "system1", "file003"), 320000, 1000)
-        self.checkSplit(os.path.join(dailyDir, "system2", "file002"), 10000, 1000)
-        self.checkSplit(os.path.join(dailyDir, "system2", "file003"), 100000, 1000)
-        self.checkSplit(os.path.join(dailyDir, "system3", "file001"), 99999, 1000)
-        self.checkSplit(os.path.join(dailyDir, "system3", "file002"), 100000, 1000)
-        self.checkSplit(os.path.join(dailyDir, "system3", "file003"), 100001, 1000)
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system1", "file001.a.b")))
+        self.assertFalse(os.path.exists(pathJoin(dailyDir, "system1", "file002")))
+        self.assertFalse(os.path.exists(pathJoin(dailyDir, "system1", "file003")))
+        self.assertTrue(os.path.exists(pathJoin(dailyDir, "system2", "file001")))
+        self.assertFalse(os.path.exists(pathJoin(dailyDir, "system2", "file002")))
+        self.assertFalse(os.path.exists(pathJoin(dailyDir, "system2", "file003")))
+        self.assertFalse(os.path.exists(pathJoin(dailyDir, "system3", "file001")))
+        self.assertFalse(os.path.exists(pathJoin(dailyDir, "system3", "file002")))
+        self.assertFalse(os.path.exists(pathJoin(dailyDir, "system3", "file003")))
+        self.checkSplit(pathJoin(dailyDir, "system1", "file002"), 32000, 1000)
+        self.checkSplit(pathJoin(dailyDir, "system1", "file003"), 320000, 1000)
+        self.checkSplit(pathJoin(dailyDir, "system2", "file002"), 10000, 1000)
+        self.checkSplit(pathJoin(dailyDir, "system2", "file003"), 100000, 1000)
+        self.checkSplit(pathJoin(dailyDir, "system3", "file001"), 99999, 1000)
+        self.checkSplit(pathJoin(dailyDir, "system3", "file002"), 100000, 1000)
+        self.checkSplit(pathJoin(dailyDir, "system3", "file003"), 100001, 1000)
diff -pruN 3.5.4-1/tests/test_util.py 3.6.0-1/tests/test_util.py
--- 3.5.4-1/tests/test_util.py	2021-01-17 21:04:43.000000000 +0000
+++ 3.6.0-1/tests/test_util.py	2021-02-03 20:03:27.000000000 +0000
@@ -117,6 +117,7 @@ from CedarBackup3.util import (
     isStartOfWeek,
     nullDevice,
     parseCommaSeparatedString,
+    pathJoin,
     resolveCommand,
     sortDict,
     splitCommandLine,
@@ -135,7 +136,7 @@ RESOURCES = [
 # This is a command that is always valid on the platform, something other than the Python interpreter
 # The command must return a success status (zero) for the tests to pass
 if platformWindows():
-    VALID_COMMAND = [os.path.join(os.environ["SystemRoot"], "system32", "WindowsPowerShell", "v1.0", "powershell.exe")]
+    VALID_COMMAND = [pathJoin(os.environ["SystemRoot"], "system32", "WindowsPowerShell", "v1.0", "powershell.exe")]
     VALID_ARGS = ["Write-Output hello"]
     VALID_OUTPUT = "hello\r\n"
 else:
@@ -4120,7 +4121,7 @@ class TestFunctions(unittest.TestCase):
         Test for "/"
         """
         path = "/"
-        expected = "-"
+        expected = "_"
         actual = buildNormalizedPath(path)
         self.assertEqual(expected, actual)
 
@@ -4129,7 +4130,7 @@ class TestFunctions(unittest.TestCase):
         Test for "\\"
         """
         path = "\\"
-        expected = "-"
+        expected = "_"
         actual = buildNormalizedPath(path)
         self.assertEqual(expected, actual)
 
@@ -4223,6 +4224,33 @@ class TestFunctions(unittest.TestCase):
         actual = buildNormalizedPath(path)
         self.assertEqual(expected, actual)
 
+    def testBuildNormalizedPath018(self):
+        """
+        Test for Windows path with drive letter and slashes.
+        """
+        path = "c:/Users/pronovic/projects/repos"
+        expected = "c-Users-pronovic-projects-repos"
+        actual = buildNormalizedPath(path)
+        self.assertEqual(expected, actual)
+
+    def testBuildNormalizedPath019(self):
+        """
+        Test for Windows path with drive letter and backslashes.
+        """
+        path = r"c:\Users\pronovic\projects\repos"
+        expected = "c-Users-pronovic-projects-repos"
+        actual = buildNormalizedPath(path)
+        self.assertEqual(expected, actual)
+
+    def testBuildNormalizedPath020(self):
+        """
+        Test for path with embedded colon.
+        """
+        path = "/path/to/whatever/key:value"
+        expected = "path-to-whatever-key_value"
+        actual = buildNormalizedPath(path)
+        self.assertEqual(expected, actual)
+
     ##########################
     # Test splitCommandLine()
     ##########################
diff -pruN 3.5.4-1/tests/test_writers_util.py 3.6.0-1/tests/test_writers_util.py
--- 3.5.4-1/tests/test_writers_util.py	2021-01-17 21:04:43.000000000 +0000
+++ 3.6.0-1/tests/test_writers_util.py	2021-02-03 20:03:27.000000000 +0000
@@ -106,7 +106,7 @@ from CedarBackup3.testutil import (
     removedir,
     setupOverrides,
 )
-from CedarBackup3.util import executeCommand
+from CedarBackup3.util import executeCommand, pathJoin
 from CedarBackup3.writers.util import IsoImage, validateDriveSpeed, validateScsiId
 
 #######################################################################
@@ -995,7 +995,7 @@ class TestIsoImage(unittest.TestCase):
         isoImage = IsoImage(graftPoint="p")
         self.assertEqual({}, isoImage.entries)
         isoImage.addEntry(dir1)
-        self.assertEqual({dir1: os.path.join("p", "tree9")}, isoImage.entries)
+        self.assertEqual({dir1: pathJoin("p", "tree9")}, isoImage.entries)
 
     def testAddEntry_011(self):
         """
@@ -1006,7 +1006,7 @@ class TestIsoImage(unittest.TestCase):
         isoImage = IsoImage()
         self.assertEqual({}, isoImage.entries)
         isoImage.addEntry(dir1, graftPoint="s")
-        self.assertEqual({dir1: os.path.join("s", "tree9")}, isoImage.entries)
+        self.assertEqual({dir1: pathJoin("s", "tree9")}, isoImage.entries)
 
     def testAddEntry_012(self):
         """
@@ -1233,7 +1233,7 @@ class TestIsoImage(unittest.TestCase):
         fsList.addDirContents(mountPath)
         self.assertEqual(2, len(fsList))
         self.assertTrue(mountPath in fsList)
-        self.assertTrue(os.path.join(mountPath, "dir002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "dir002") in fsList)
 
     @unittest.skipUnless(runAllTests(), "Limited test suite")
     def testWriteImage_003(self):
@@ -1251,8 +1251,8 @@ class TestIsoImage(unittest.TestCase):
         fsList.addDirContents(mountPath)
         self.assertEqual(3, len(fsList))
         self.assertTrue(mountPath in fsList)
-        self.assertTrue(os.path.join(mountPath, "base") in fsList)
-        self.assertTrue(os.path.join(mountPath, "base", "dir002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "base") in fsList)
+        self.assertTrue(pathJoin(mountPath, "base", "dir002") in fsList)
 
     @unittest.skipUnless(runAllTests(), "Limited test suite")
     def testWriteImage_004(self):
@@ -1271,15 +1271,15 @@ class TestIsoImage(unittest.TestCase):
         fsList.addDirContents(mountPath)
         self.assertEqual(10, len(fsList))
         self.assertTrue(mountPath in fsList)
-        self.assertTrue(os.path.join(mountPath, "dir002") in fsList)
-        self.assertTrue(os.path.join(mountPath, "dir002", "file001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "dir002", "file002") in fsList)
-        self.assertTrue(os.path.join(mountPath, "dir002", "link001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "dir002", "link002") in fsList)
-        self.assertTrue(os.path.join(mountPath, "dir002", "link003") in fsList)
-        self.assertTrue(os.path.join(mountPath, "dir002", "link004") in fsList)
-        self.assertTrue(os.path.join(mountPath, "dir002", "dir001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "dir002", "dir002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "dir002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "dir002", "file001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "dir002", "file002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "dir002", "link001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "dir002", "link002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "dir002", "link003") in fsList)
+        self.assertTrue(pathJoin(mountPath, "dir002", "link004") in fsList)
+        self.assertTrue(pathJoin(mountPath, "dir002", "dir001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "dir002", "dir002") in fsList)
 
     @unittest.skipUnless(runAllTests(), "Limited test suite")
     def testWriteImage_005(self):
@@ -1291,24 +1291,24 @@ class TestIsoImage(unittest.TestCase):
         isoImage = IsoImage()
         dir1 = self.buildPath(["tree9", "dir002"])
         imagePath = self.buildPath(["image.iso"])
-        isoImage.addEntry(dir1, graftPoint=os.path.join("something", "else"))
+        isoImage.addEntry(dir1, graftPoint=pathJoin("something", "else"))
         isoImage.writeImage(imagePath)
         mountPath = self.mountImage(imagePath)
         fsList = FilesystemList()
         fsList.addDirContents(mountPath)
         self.assertEqual(12, len(fsList))
         self.assertTrue(mountPath in fsList)
-        self.assertTrue(os.path.join(mountPath, "something") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "else") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "else", "dir002") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "else", "dir002", "file001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "else", "dir002", "file002") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "else", "dir002", "link001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "else", "dir002", "link002") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "else", "dir002", "link003") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "else", "dir002", "link004") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "else", "dir002", "dir001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "else", "dir002", "dir002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "else") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "else", "dir002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "else", "dir002", "file001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "else", "dir002", "file002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "else", "dir002", "link001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "else", "dir002", "link002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "else", "dir002", "link003") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "else", "dir002", "link004") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "else", "dir002", "dir001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "else", "dir002", "dir002") in fsList)
 
     @unittest.skipUnless(runAllTests(), "Limited test suite")
     def testWriteImage_006(self):
@@ -1326,7 +1326,7 @@ class TestIsoImage(unittest.TestCase):
         fsList.addDirContents(mountPath)
         self.assertEqual(2, len(fsList))
         self.assertTrue(mountPath in fsList)
-        self.assertTrue(os.path.join(mountPath, "file001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "file001") in fsList)
 
     @unittest.skipUnless(runAllTests(), "Limited test suite")
     def testWriteImage_007(self):
@@ -1344,8 +1344,8 @@ class TestIsoImage(unittest.TestCase):
         fsList.addDirContents(mountPath)
         self.assertEqual(3, len(fsList))
         self.assertTrue(mountPath in fsList)
-        self.assertTrue(os.path.join(mountPath, "point") in fsList)
-        self.assertTrue(os.path.join(mountPath, "point", "file001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "point") in fsList)
+        self.assertTrue(pathJoin(mountPath, "point", "file001") in fsList)
 
     @unittest.skipUnless(runAllTests(), "Limited test suite")
     def testWriteImage_008(self):
@@ -1366,8 +1366,8 @@ class TestIsoImage(unittest.TestCase):
         fsList.addDirContents(mountPath)
         self.assertEqual(3, len(fsList))
         self.assertTrue(mountPath in fsList)
-        self.assertTrue(os.path.join(mountPath, "file001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "dir002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "file001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "dir002") in fsList)
 
     @unittest.skipUnless(runAllTests(), "Limited test suite")
     def testWriteImage_009(self):
@@ -1388,10 +1388,10 @@ class TestIsoImage(unittest.TestCase):
         fsList.addDirContents(mountPath)
         self.assertEqual(5, len(fsList))
         self.assertTrue(mountPath in fsList)
-        self.assertTrue(os.path.join(mountPath, "other") in fsList)
-        self.assertTrue(os.path.join(mountPath, "base") in fsList)
-        self.assertTrue(os.path.join(mountPath, "other", "file001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "base", "dir002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "other") in fsList)
+        self.assertTrue(pathJoin(mountPath, "base") in fsList)
+        self.assertTrue(pathJoin(mountPath, "other", "file001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "base", "dir002") in fsList)
 
     @unittest.skipUnless(runAllTests(), "Limited test suite")
     def testWriteImage_010(self):
@@ -1412,16 +1412,16 @@ class TestIsoImage(unittest.TestCase):
         fsList.addDirContents(mountPath)
         self.assertEqual(11, len(fsList))
         self.assertTrue(mountPath in fsList)
-        self.assertTrue(os.path.join(mountPath, "base") in fsList)
-        self.assertTrue(os.path.join(mountPath, "base", "file001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "base", "dir001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "base", "dir001", "file001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "base", "dir001", "file002") in fsList)
-        self.assertTrue(os.path.join(mountPath, "base", "dir001", "link001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "base", "dir001", "link002") in fsList)
-        self.assertTrue(os.path.join(mountPath, "base", "dir001", "link003") in fsList)
-        self.assertTrue(os.path.join(mountPath, "base", "dir001", "dir001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "base", "dir001", "dir002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "base") in fsList)
+        self.assertTrue(pathJoin(mountPath, "base", "file001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "base", "dir001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "base", "dir001", "file001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "base", "dir001", "file002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "base", "dir001", "link001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "base", "dir001", "link002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "base", "dir001", "link003") in fsList)
+        self.assertTrue(pathJoin(mountPath, "base", "dir001", "dir001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "base", "dir001", "dir002") in fsList)
 
     @unittest.skipUnless(runAllTests(), "Limited test suite")
     def testWriteImage_011(self):
@@ -1444,18 +1444,18 @@ class TestIsoImage(unittest.TestCase):
         fsList.addDirContents(mountPath)
         self.assertEqual(13, len(fsList))
         self.assertTrue(mountPath in fsList)
-        self.assertTrue(os.path.join(mountPath, "base") in fsList)
-        self.assertTrue(os.path.join(mountPath, "other") in fsList)
-        self.assertTrue(os.path.join(mountPath, "file001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "other", "file002") in fsList)
-        self.assertTrue(os.path.join(mountPath, "base", "dir001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "base", "dir001", "file001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "base", "dir001", "file002") in fsList)
-        self.assertTrue(os.path.join(mountPath, "base", "dir001", "link001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "base", "dir001", "link002") in fsList)
-        self.assertTrue(os.path.join(mountPath, "base", "dir001", "link003") in fsList)
-        self.assertTrue(os.path.join(mountPath, "base", "dir001", "dir001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "base", "dir001", "dir002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "base") in fsList)
+        self.assertTrue(pathJoin(mountPath, "other") in fsList)
+        self.assertTrue(pathJoin(mountPath, "file001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "other", "file002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "base", "dir001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "base", "dir001", "file001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "base", "dir001", "file002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "base", "dir001", "link001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "base", "dir001", "link002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "base", "dir001", "link003") in fsList)
+        self.assertTrue(pathJoin(mountPath, "base", "dir001", "dir001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "base", "dir001", "dir002") in fsList)
 
     @unittest.skipUnless(runAllTests(), "Limited test suite")
     def testWriteImage_012(self):
@@ -1473,29 +1473,29 @@ class TestIsoImage(unittest.TestCase):
         fsList.addDirContents(mountPath)
         self.assertEqual(24, len(fsList))
         self.assertTrue(mountPath in fsList)
-        self.assertTrue(os.path.join(mountPath, "something") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "tree9") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "tree9", "file001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "tree9", "file002") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "tree9", "link001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "tree9", "link002") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "tree9", "dir001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "tree9", "dir001", "file001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "tree9", "dir001", "file002") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "tree9", "dir001", "link001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "tree9", "dir001", "link002") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "tree9", "dir001", "link003") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "tree9", "dir001", "dir001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "tree9", "dir001", "dir002") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "tree9", "dir002") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "tree9", "dir002", "file001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "tree9", "dir002", "file002") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "tree9", "dir002", "link001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "tree9", "dir002", "link002") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "tree9", "dir002", "link003") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "tree9", "dir002", "link004") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "tree9", "dir002", "dir001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "tree9", "dir002", "dir002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "tree9") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "tree9", "file001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "tree9", "file002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "tree9", "link001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "tree9", "link002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "tree9", "dir001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "tree9", "dir001", "file001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "tree9", "dir001", "file002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "tree9", "dir001", "link001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "tree9", "dir001", "link002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "tree9", "dir001", "link003") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "tree9", "dir001", "dir001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "tree9", "dir001", "dir002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "tree9", "dir002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "tree9", "dir002", "file001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "tree9", "dir002", "file002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "tree9", "dir002", "link001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "tree9", "dir002", "link002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "tree9", "dir002", "link003") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "tree9", "dir002", "link004") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "tree9", "dir002", "dir001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "tree9", "dir002", "dir002") in fsList)
 
     @unittest.skipUnless(runAllTests(), "Limited test suite")
     def testWriteImage_013(self):
@@ -1532,7 +1532,7 @@ class TestIsoImage(unittest.TestCase):
         fsList.addDirContents(mountPath)
         self.assertEqual(2, len(fsList))
         self.assertTrue(mountPath in fsList)
-        self.assertTrue(os.path.join(mountPath, "base") in fsList)
+        self.assertTrue(pathJoin(mountPath, "base") in fsList)
 
     @unittest.skipUnless(runAllTests(), "Limited test suite")
     def testWriteImage_015(self):
@@ -1551,14 +1551,14 @@ class TestIsoImage(unittest.TestCase):
         fsList.addDirContents(mountPath)
         self.assertEqual(9, len(fsList))
         self.assertTrue(mountPath in fsList)
-        self.assertTrue(os.path.join(mountPath, "file001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "file002") in fsList)
-        self.assertTrue(os.path.join(mountPath, "link001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "link002") in fsList)
-        self.assertTrue(os.path.join(mountPath, "link003") in fsList)
-        self.assertTrue(os.path.join(mountPath, "link004") in fsList)
-        self.assertTrue(os.path.join(mountPath, "dir001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "dir002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "file001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "file002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "link001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "link002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "link003") in fsList)
+        self.assertTrue(pathJoin(mountPath, "link004") in fsList)
+        self.assertTrue(pathJoin(mountPath, "dir001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "dir002") in fsList)
 
     @unittest.skipUnless(runAllTests(), "Limited test suite")
     def testWriteImage_016(self):
@@ -1570,23 +1570,23 @@ class TestIsoImage(unittest.TestCase):
         isoImage = IsoImage()
         dir1 = self.buildPath(["tree9", "dir002"])
         imagePath = self.buildPath(["image.iso"])
-        isoImage.addEntry(dir1, graftPoint=os.path.join("something", "else"), contentsOnly=True)
+        isoImage.addEntry(dir1, graftPoint=pathJoin("something", "else"), contentsOnly=True)
         isoImage.writeImage(imagePath)
         mountPath = self.mountImage(imagePath)
         fsList = FilesystemList()
         fsList.addDirContents(mountPath)
         self.assertEqual(11, len(fsList))
         self.assertTrue(mountPath in fsList)
-        self.assertTrue(os.path.join(mountPath, "something") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "else") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "else", "file001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "else", "file002") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "else", "link001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "else", "link002") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "else", "link003") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "else", "link004") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "else", "dir001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "else", "dir002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "else") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "else", "file001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "else", "file002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "else", "link001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "else", "link002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "else", "link003") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "else", "link004") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "else", "dir001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "else", "dir002") in fsList)
 
     @unittest.skipUnless(runAllTests(), "Limited test suite")
     def testWriteImage_017(self):
@@ -1605,7 +1605,7 @@ class TestIsoImage(unittest.TestCase):
         fsList.addDirContents(mountPath)
         self.assertEqual(2, len(fsList))
         self.assertTrue(mountPath in fsList)
-        self.assertTrue(os.path.join(mountPath, "file001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "file001") in fsList)
 
     @unittest.skipUnless(runAllTests(), "Limited test suite")
     def testWriteImage_018(self):
@@ -1624,8 +1624,8 @@ class TestIsoImage(unittest.TestCase):
         fsList.addDirContents(mountPath)
         self.assertEqual(3, len(fsList))
         self.assertTrue(mountPath in fsList)
-        self.assertTrue(os.path.join(mountPath, "point") in fsList)
-        self.assertTrue(os.path.join(mountPath, "point", "file001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "point") in fsList)
+        self.assertTrue(pathJoin(mountPath, "point", "file001") in fsList)
 
     @unittest.skipUnless(runAllTests(), "Limited test suite")
     def testWriteImage_019(self):
@@ -1646,7 +1646,7 @@ class TestIsoImage(unittest.TestCase):
         fsList.addDirContents(mountPath)
         self.assertEqual(2, len(fsList))
         self.assertTrue(mountPath in fsList)
-        self.assertTrue(os.path.join(mountPath, "file001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "file001") in fsList)
 
     @unittest.skipUnless(runAllTests(), "Limited test suite")
     def testWriteImage_020(self):
@@ -1667,9 +1667,9 @@ class TestIsoImage(unittest.TestCase):
         fsList.addDirContents(mountPath)
         self.assertEqual(4, len(fsList))
         self.assertTrue(mountPath in fsList)
-        self.assertTrue(os.path.join(mountPath, "other") in fsList)
-        self.assertTrue(os.path.join(mountPath, "base") in fsList)
-        self.assertTrue(os.path.join(mountPath, "other", "file001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "other") in fsList)
+        self.assertTrue(pathJoin(mountPath, "base") in fsList)
+        self.assertTrue(pathJoin(mountPath, "other", "file001") in fsList)
 
     @unittest.skipUnless(runAllTests(), "Limited test suite")
     def testWriteImage_021(self):
@@ -1707,17 +1707,17 @@ class TestIsoImage(unittest.TestCase):
         fsList.addDirContents(mountPath)
         self.assertEqual(12, len(fsList))
         self.assertTrue(mountPath in fsList)
-        self.assertTrue(os.path.join(mountPath, "base") in fsList)
-        self.assertTrue(os.path.join(mountPath, "other") in fsList)
-        self.assertTrue(os.path.join(mountPath, "file001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "other", "file002") in fsList)
-        self.assertTrue(os.path.join(mountPath, "base", "file001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "base", "file002") in fsList)
-        self.assertTrue(os.path.join(mountPath, "base", "link001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "base", "link002") in fsList)
-        self.assertTrue(os.path.join(mountPath, "base", "link003") in fsList)
-        self.assertTrue(os.path.join(mountPath, "base", "dir001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "base", "dir002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "base") in fsList)
+        self.assertTrue(pathJoin(mountPath, "other") in fsList)
+        self.assertTrue(pathJoin(mountPath, "file001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "other", "file002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "base", "file001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "base", "file002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "base", "link001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "base", "link002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "base", "link003") in fsList)
+        self.assertTrue(pathJoin(mountPath, "base", "dir001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "base", "dir002") in fsList)
 
     @unittest.skipUnless(runAllTests(), "Limited test suite")
     def testWriteImage_023(self):
@@ -1736,25 +1736,25 @@ class TestIsoImage(unittest.TestCase):
         fsList.addDirContents(mountPath)
         self.assertEqual(23, len(fsList))
         self.assertTrue(mountPath in fsList)
-        self.assertTrue(os.path.join(mountPath, "something") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "file001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "file002") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "link001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "link002") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "dir001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "dir001", "file001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "dir001", "file002") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "dir001", "link001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "dir001", "link002") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "dir001", "link003") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "dir001", "dir001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "dir001", "dir002") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "dir002") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "dir002", "file001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "dir002", "file002") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "dir002", "link001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "dir002", "link002") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "dir002", "link003") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "dir002", "link004") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "dir002", "dir001") in fsList)
-        self.assertTrue(os.path.join(mountPath, "something", "dir002", "dir002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "file001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "file002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "link001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "link002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "dir001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "dir001", "file001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "dir001", "file002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "dir001", "link001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "dir001", "link002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "dir001", "link003") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "dir001", "dir001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "dir001", "dir002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "dir002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "dir002", "file001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "dir002", "file002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "dir002", "link001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "dir002", "link002") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "dir002", "link003") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "dir002", "link004") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "dir002", "dir001") in fsList)
+        self.assertTrue(pathJoin(mountPath, "something", "dir002", "dir002") in fsList)
